import getSlot from '@/utils/getSolt';
import clsx from 'clsx';
import { defineComponent, PropType, VNode } from 'vue';
import './index.scss';

export default defineComponent({
  name: 'Card',
  props: {
    header: Function as PropType<() => VNode>,
    body: Object as PropType<VNode>,
    shadow: {
      type: String as PropType<'always' | 'hover' | 'never'>,
      default: 'always',
    },
  },
  setup(props, ctx) {
    return () => (
      <div
        class={clsx('card-content', {
          'always-shadow': props.shadow === 'always' || !props.shadow,
          'hover-shadow': props.shadow === 'hover',
        })}>
        <div class="card-content-title">{props.header && props.header()}</div>
        <div class="card-content-body">
          {ctx.slots.default && ctx.slots.default()}
        </div>
      </div>
    );
  },
});
