import {
  IconArchive,
  IconCar,
  IconDepartment,
  IconDuty,
  IconEmergency,
  IconHandle,
  IconHighway,
  IconHome,
  IconIgnore,
  IconIncident,
  IconNavigation,
  IconPlan,
  IconRailway,
  IconReport,
  IconResource,
  IconRoster,
  IconSend,
  IconStorehouse,
  IconTeam,
  IconTransportation,
  IconWarning,
} from '@/constants/icon';

export const BaseMediaUrl = 'http://sqfile.xt.wenhq.top:8083';

export const MENUS_INCIDENT = {
  title: {
    name: '事件状态',
    path: '/incident-management/status' as const,
  },
  items: [
    { name: '预警', path: '/incident-management/status/1', icon: IconWarning },
    { name: '忽略', path: '/incident-management/status/2', icon: IconIgnore },
    { name: '待派发', path: '/incident-management/status/3', icon: IconSend },
    { name: '待处置', path: '/incident-management/status/4', icon: IconHandle },
    {
      name: '已归档',
      path: '/incident-management/status/5',
      icon: IconArchive,
    },
  ],
};

export const MENUS_EMERGENCY_PLAN = {
  title: { name: '应急预案', path: null },
  items: [
    {
      name: '归属部门',
      path: '/emergency-plan/department/1',
      icon: IconDepartment,
    },
    {
      name: '应急安全处',
      path: '/emergency-plan/department/2',
      icon: IconEmergency,
    },
    {
      name: '市运输服务中心',
      path: '/emergency-plan/department/3',
      icon: IconTransportation,
    },
    {
      name: '市港航事业发展中心',
      path: '/emergency-plan/department/4',
      icon: IconNavigation,
    },
    {
      name: '市铁路事业发展中心',
      path: '/emergency-plan/department/5',
      icon: IconRailway,
    },
    {
      name: '市公路事业发展中心',
      path: '/emergency-plan/department/6',
      icon: IconHighway,
    },
  ],
};

export const MENUS_EMERGENCY_RESOURCES = {
  title: { name: '应急资源', path: null },
  items: [
    {
      name: '应急仓库',
      path: '/emergency-resources/resources/1',
      icon: IconStorehouse,
    },
    {
      name: '应急队伍',
      path: '/emergency-resources/resources/2',
      icon: IconTeam,
    },
    {
      name: '应急车辆',
      path: '/emergency-resources/resources/3',
      icon: IconCar,
    },
  ],
};

export const MENUS_DUTY = {
  title: { name: '值班管理', path: null },
  items: [
    { name: '值班报告', path: '/duty-management/report', icon: IconReport },
    { name: '值班排班', path: '/duty-management/roster', icon: IconRoster },
  ],
};

export enum PATHS {
  HOME = '/home',
  INCIDENT_MANAGEMENT = '/incident-management',
  EMERGENCY_PLAN = '/emergency-plan',
  EMERGENCY_RESOURCES = '/emergency-resources',
  DUTY_MANAGEMENT = '/duty-management',
}

export const PATH_LINK_NAV_BAR_MENU = {
  'incident-management': 'MENUS_INCIDENT',
  'emergency-plan': 'MENUS_EMERGENCY_PLAN',
  'emergency-resources': 'MENUS_EMERGENCY_RESOURCES',
  'duty-management': 'MENUS_DUTY',
};

export const PATH_LINK_NAV_BAR_MENU_DICT = [
  {
    path: PATHS.INCIDENT_MANAGEMENT,
    subpath: 'status',
    dict: 'zhdd_incident_status' as const,
  },
  {
    path: PATHS.EMERGENCY_PLAN,
    subpath: 'department',
    dict: 'zhdd_org_upload' as const,
  },
  {
    path: PATHS.EMERGENCY_RESOURCES,
    subpath: 'resources',
    dict: 'zhdd_resource' as const,
  },
];

export const NAV_BAR_MENUS = [
  { name: '首页', path: PATHS.HOME, icon: IconHome },
  {
    name: '事件管理',
    path: PATHS.INCIDENT_MANAGEMENT,
    icon: IconIncident,
  },
  {
    name: '应急预案',
    path: PATHS.EMERGENCY_PLAN,
    icon: IconPlan,
  },
  {
    name: '应急资源',
    path: PATHS.EMERGENCY_RESOURCES,
    icon: IconResource,
  },
  {
    name: '值班管理',
    path: PATHS.DUTY_MANAGEMENT,
    icon: IconDuty,
  },
];
